[changes]
### i-net Crystal-Clear runtime
* New API methods:
  * FieldElement.setBaseURL="../../String". It is now possible to set the "Base URL" for field elements interpreted as HTML. This causes any relative links in the element to use the base URL as the base.
  * ReportProperties.setReportLocale(java.util.Locale). It is now possible to set a locale that is different to the server locale and that will be used for formatting CDbl, ToText etc.
* New Formula functions:
  * UnixTimeStampToDateTime: Converts a UNIX timestamp into a date/time object.
  * ActualPageNumber: Returns the actual, current page number.
  * SelectionLocale: Returns the servers default locale used to generate the current report.
* Excel export: The Option "fit print output to page width" is set for excel export. Thus if the width of the sheet content doesn't fit the page width, the sheet content will be automatically scaled to fit the page width.
* Postscript export: Compression of monochrome blob images supported.
* HTML export: Attributes 'scope' are written in crosstab column- and row headers for 508 Compliance.
* Property "Clear On New Request" added. If the value is true the whole cache will be cleared on next request.
* Chart:
  * Combined Charts (Dual Axis Charts) supported.
  * A new flag added to legend properties. This sorts the legend labels ascending or descending depending of the sort order of the second group.
* Trailing white spaces in char columns are truncated (in version 8.2.385).
* If the maximum number of errors was reached, the last error causing the canceling of the report is now displayed.
* Faster string comparison when rendering with multiple threads.
* If rendering was stopped (engine.stop) then data fetching and sorting will be stopped, also.
* Database Meta Data Cache: Availability of values improved.
* Formula Functions:
  * Function TextFromFile supports URL's with protocols other than "file", e.g. "http".
  * If the result of a logical operation is determined by the left operand, the right one will no longer be evaluated. Note, that even operations, that modify any data will not be executed in that case!
  * Function Color now also accepts 4 parameters, the 4th being the alpha value of the color. Alternatively you can use the function RGBA.
  * New parameter types added to the formula function toText so that they can use the system default formats.
  * Reading very long formulas has been accelerated (in version 8.2.422).

#### API Changes
* Added Methods
  * FieldElement.getBaseUrl="changes_8.2.html" data-contextid="changes-in-release-82" data-rawid="documentation:clear-reports:release-notes:en:releases:changes_8.2"
  * FieldElement.setBaseURL="../../String"
  * FieldElement.getBaseUrlFormula()
  * FieldElement.setBaseUrlFormula(FormulaField)
  * ReportProperties.setReportLocale(java.util.Locale)
  * ReportProperties.getReportLocale()

### i-net Crystal-Clear - Java Viewer
* It is supported to change the language of the Java viewer by changing the Locale.
* NEW API: SwingReportViewer now has two new methods: setPrinterDefaultFormatHandling and getPrinterDefaultFormatHandling. Changing the default handling enables you to have a report designed for Letter, but printed on an A4 printer (or vice versa), have the paper size set to the printer default by default rather than to the paper size designed in the report. See the API documentation for more info.
* Russian translation of the GUI added (in version 8.2.305).
* It is possible to scroll between pages with the mouse wheel. This behavior was optimized to not switch pages with such a high sensitivity.
* Excel export: The option "fit print output to page width" is set for excel export. Thus if the width of the sheet content doesn't fit the page width, the sheet content will be automatically scaled to fit the page width.
* Parameter Fields directly placed into the report now use the "ToText" function for their string representation, which especially improves the representation of date range prompts.

#### API Changes
* Added Methods
  * SwingReportViewer.getPrinterDefaultFormatHandling()
  * SwingReportViewer.setPrinterDefaultFormatHandling(int)

### i-net DesignerXML
* Group Dialog:
  * Second original sort order "Original Order Collect Values" now available. This collects only the same values located nearby, and begins a new group whenever the value changes in the group field.
  * BySummaryOrder now accepts values in percent.
  * Error bar added to the status bar. The error bar shows the last errors which occurred when previewing the report.
* The fonts that are located in the "Font Path" - directory for embedded fonts will be registered. Thus these fonts will be show at design time additionally to the installed fonts.

### i-net Scheduler
* It is now possible to enable/disable the scheduler web interface without restarting the scheduler.
* Error Handling improved.

[changes:de]
### i-net Crystal-Clear-Laufzeit
* Neue API-Methoden:
  * FieldElement.setBaseURL="../../String". Es ist nun möglich, die "Base URL" für Feldelemente, die als HTML interpretiert werden, zu setzen. Dies bewirkt, dass alle relativen Links im Element die Basis-URL als Grundlage verwenden.
  * ReportProperties.setReportLocale(java.util.Locale). Es ist jetzt möglich, ein anderes Gebietsschema als das des Servers festzulegen, das für die Formatierung von CDbl, ToText usw. verwendet wird.
* Neue Formelfunktionen:
  * UnixTimeStampToDateTime: Konvertiert einen UNIX-Zeitstempel in ein Datum/Zeit-Objekt.
  * ActualPageNumber: Gibt die tatsächliche, aktuelle Seitenzahl zurück.
  * AuswahlLocale: Gibt das Standardgebietsschema des Servers zurück, das für die Erstellung des aktuellen Berichts verwendet wurde.
* Excel-Ausgabe: Die Option "Druckausgabe an Seitenbreite anpassen" ist für den Excel-Export gesetzt. Wenn also die Breite des Blattinhalts nicht mit der Seitenbreite übereinstimmt, wird der Blattinhalt automatisch an die Seitenbreite angepasst.
* Postscript-Export: Komprimierung von monochromen Blob-Bildern wird unterstützt.
* HTML-Export: Attribute 'scope' werden in Kreuztabellen-Spalten- und -Zeilenköpfe für 508 Compliance geschrieben.
* Eigenschaft "Clear On New Request" hinzugefügt. Wenn der Wert true ist, wird der gesamte Cache bei der nächsten Anfrage geleert.
* Diagramm:
  * Kombinierte Diagramme (Diagramme mit zwei Achsen) werden unterstützt.
  * Ein neues Flag wurde zu den Legendeneigenschaften hinzugefügt. Damit werden die Legendenbeschriftungen auf- oder absteigend sortiert, abhängig von der Sortierreihenfolge der zweiten Gruppe.
* Nachfolgende Leerzeichen in Char-Spalten werden abgeschnitten (in Version 8.2.385).

* Wenn die maximale Anzahl von Fehlern erreicht wurde, wird nun der letzte Fehler, der zum Abbruch des Berichts führte, angezeigt.
* Schnellerer String-Vergleich beim Rendering mit mehreren Threads.
* Wenn das Rendering gestoppt wurde (engine.stop), wird auch das Holen und Sortieren von Daten gestoppt.
* Datenbank-Metadaten-Cache: Die Verfügbarkeit von Werten wurde verbessert.
* Formel-Funktionen:
  * Die Funktion TextFromFile unterstützt URL's mit anderen Protokollen als "file", z.B. "http".
  * Wenn das Ergebnis einer logischen Operation durch den linken Operanden bestimmt wird, wird der rechte Operand nicht mehr ausgewertet. Beachten Sie, dass auch Operationen, die irgendwelche Daten verändern, in diesem Fall nicht ausgeführt werden!
  * Die Funktion Farbe akzeptiert nun auch 4 Parameter, wobei der 4. der Alphawert der Farbe ist. Alternativ können Sie auch die Funktion RGBA verwenden.
  * Der Formelfunktion toText wurden neue Parametertypen hinzugefügt, so dass sie die Standardformate des Systems verwenden können.
  * Das Lesen sehr langer Formeln wurde beschleunigt (in Version 8.2.422).

#### API-Änderungen
* Hinzugefügte Methoden
  * FieldElement.getBaseUrl="changes_8.2.html" data-contextid="changes-in-release-82" data-rawid="documentation:clear-reports:release-notes:de:releases:changes_8.2"
  * FieldElement.setBaseURL="../../String"
  * FieldElement.getBaseUrlFormula()
  * FieldElement.setBaseUrlFormula(FormulaField)
  * ReportProperties.setReportLocale(java.util.Locale)
  * ReportProperties.getReportLocale()

### i-net Crystal-Clear - Java Viewer
* Es wird unterstützt, die Sprache des Java-Viewers zu ändern, indem das Gebietsschema geändert wird.
* NEUE API: SwingReportViewer hat jetzt zwei neue Methoden: setPrinterDefaultFormatHandling und getPrinterDefaultFormatHandling. Wenn Sie das Standardhandling ändern, können Sie einen Bericht, der für das Format Letter entworfen wurde, aber auf einem A4-Drucker gedruckt wird (oder umgekehrt), standardmäßig auf das Papierformat des Druckers und nicht auf das im Bericht entworfene Papierformat einstellen. Siehe die API-Dokumentation für weitere Informationen.
* Russische Übersetzung der GUI hinzugefügt (in Version 8.2.305).

* Es ist möglich, mit dem Mausrad zwischen den Seiten zu blättern. Dieses Verhalten wurde optimiert, damit die Seiten nicht so empfindlich gewechselt werden.
* Excel-Export: Beim Excel-Export ist die Option "Druckausgabe an Seitenbreite anpassen" gesetzt. Wenn also die Breite des Blattinhalts nicht zur Seitenbreite passt, wird der Blattinhalt automatisch an die Seitenbreite angepasst.
* Parameterfelder, die direkt im Bericht platziert werden, verwenden jetzt die Funktion "ToText" für ihre String-Darstellung, was insbesondere die Darstellung von Datumsbereichsabfragen verbessert.

#### API-Änderungen
* Methoden hinzugefügt
  * SwingReportViewer.getPrinterDefaultFormatHandling()
  * SwingReportViewer.setPrinterDefaultFormatHandling(int)

### i-net DesignerXML
* Gruppen-Dialog:
  * Zweite Original-Sortierreihenfolge "Original Order Collect Values" jetzt verfügbar. Dies sammelt nur die gleichen Werte, die sich in der Nähe befinden, und beginnt eine neue Gruppe, wenn sich der Wert im Gruppenfeld ändert.
  * BySummaryOrder akzeptiert jetzt auch Werte in Prozent.
  * Fehlerleiste zur Statusleiste hinzugefügt. Die Fehlerleiste zeigt die letzten Fehler an, die bei der Vorschau des Berichts aufgetreten sind.

* Die Schriftarten, die sich im "Font Path" - Verzeichnis für eingebettete Schriftarten befinden, werden registriert. Somit werden diese Schriften zur Entwurfszeit zusätzlich zu den installierten Schriften angezeigt.

### i-net Scheduler
* Es ist nun möglich, die Web-Schnittstelle des Schedulers zu aktivieren/deaktivieren, ohne den Scheduler neu zu starten.
* Die Fehlerbehandlung wurde verbessert.

[bugfixes]
### i-net Crystal-Clear runtime
* In some cases the configuration was unnecessarily read twice during startup of i-net Crystal-Clear. This slowed down the performance of the startup and has been fixed.
* Exception occurred while using number format property formulas in cross-tab cells, which contains the keyword "currentfieldvalue".
* "Can Grow" fields with trailing spaces would show up with an unwanted line break.
* It was not possible to translate the "Total" label in cross-tab using language resources.
* Connection leak has occurred if database connection was set with method setConnection and parameter field values were requested from the Java viewer.
* Formula function MIRR: Result of the formula function was wrong.
* ClassCastException occurred if property "Log Database Data" (CCcore file creation) was enabled.
* In case the text interpretation was set dynamically and changed throughout the report, a rare "ClassCastException: com.inet.report.PageBreakInfo cannot be cast to com.inet.report.layout.ric.RichHtmlPageBreakInfo" could occur.
* In rare cases lines and boxes were rendered incorrect if they are included in the page header or page footer of a report and that was added as sub-report.
* In rare cases, a report could have been saved incorrectly which then caused the report to be able to be loaded, but not saved again.
* Query files not found if they were set using UNC names.
* Round-up has not worked correctly for small values and all values of the Rounding property.
* It is no longer necessary for the SQL query for dynamic prompt default values to have the value and description columns be columns 1 and 2. Rather you can now name the columns "value" and "description" and their order can then be as desired.
* Database Meta Data Cache does not used database connections set with method setConnection.
* Regression: An incorrect error was thrown after the same engine was executed twice.
* PDF export: Representation of blank content was wrong. Page in PDF file was blank if total page element was empty.
* RTF export: Windows Metafile show correct line stroke with extended pen. This GDI-object is used now instead of simple pen.
* Record Selection Formula: Fix for in-Array operations used in the record selection formula. The in-Array operation will now return always false if the array is empty. This has an impact on an empty multi-value prompt for instance, which returns an empty array as well.
* Chart:
  * Incorrect label of data axis by continuous date chart.
  * Outline of Doughnut 2D chart was always drawn.
  * The separators of ring 2D were not defined by items outline.
  * The color order of chart items was dependent from legend.
  * The list of legend labels from second group is now sorted by sort order of this group.
* SVG Bean (com.inet.report.beans.SVG): NullPointerException occurred.
* Sometimes a section disappeared if the Page Footer section was suppressed depending on a formula.
* RuntimeException: Field is null occurred while opening a report designed with Crystal Reports.
* Line styles of a box in a sub-report was sometimes used for a box in the main report, also.
* Web server stops responding after some errors in the record selection formula had occurred.
* TXT export: Chinese data were shifted sometimes if the data contains the Chinese character "VIII".
* ODBC driver for Excel mark all sheets as SYSTEM TABLE. Therefore no objects has been displayed in the Visual Database Wizard.
* Drill Down not worked because of an encoding problem if script language like ASP or PHP used.
* TXT export: Chinese data were shifted sometimes.
* Wrong result of DateDiff function with a DayOfWeek offset occurred if the difference was a multiple of seven days.
* IllegalArgumentException occurred while opening report file after parameter field type has changed (fixed in build 8.2.245).
* Because of an exception occurred while reading sproc parameter values for a store procedure (e.g. on Informix) the value for some stored procedure parameters was null (fixed in build 8.2.247).
* Non-ASCII characters in parameter field names are not displayed correctly in the HTML Parameter Request dialog. (in version 8.2.305).
* Endless loop occurred if Underlay Following Section was enabled for a large section (fixed in version 8.2.422).
* StackOverflowError occurred if nested if-then-else statements used in formulas (fixed in version 8.2.436).
* An endless loop could occur in rare cases if metadata cache was enabled. (fixed in version 8.2.441).
* Security issue: Using a modified report URL, it was possible to download files from the i-net Crystal-Clear web context, if the file crystal.war was unpacked (fixed in version 8.2.445).
* Excel Export:
  * Cross-Tab in the .xls file was incomplete. The the first column was not exported (fixed in version 8.2.445).
  * Position of the '%' symbol has not been set for log level less the WARNING (fixed in version 8.2.519).
* Data export:
  * It has occurred that columns of the exported csv file contains records of multiple database fields or special fields, e.g. Page Number (fixed in version 8.2.540).
* Property "OnError_ExecuteSQL_WithoutSF" was ignored if an error occurred during execution of Order By and Where clause (fixed in version 8.2.540).
* Endless loop occurred because of java.util.WeakHashMap, which a non-thread safe object.
* Security fix to prevent cross-site scripting (XSS) (fixed in version 8.2.959).

### i-net Crystal-Clear - Java Viewer
* Various bugs regarding searching with regular expressions in the Java viewer have occurred.
* HTML errors coming from the server are no longer shown in a garbled manner in the viewer's error dialog, but as an HTML-formatted error box.
* If a prompt field was set to accept default values only but had no default values, it would show up as an not editable empty field. Now it accepts a user entry in this case.
* When setting empty default values and "default values only", some prompt issues could occur such as an empty prompt box.
* Pressing "More Info" in an error box coming from the report viewer within the Designer has no effect.
* A rare IndexOutOfBoundsException occurred in the viewer when attempting to fetch a report for which the client had no reading permissions.
* Links to "file:" files in a report did not work in the viewer applet due to Java security issues. This has been fixed for Java 6.
* Landscape reports were not printed correctly if "2 Pages per Sheet" was set in the print dialog of the Java report viewer.
* In some cases the state of the PrinterJobProgress was wrong after an error occurred. Therefore the PrinterJobProgress has not returned the error.
* A NullPointerException in RichTextLayouter could occur in rare cases for elements with mixed text and field parts extending over multiple lines.
* A memory leak in the viewer occurred when opening and closing individual report viewers.
* Prompt request dialog was not displayed after refresh, when using new URLRenderData, if "promptonrefresh=true" was given as a URL property instead of being set via API.
* Screen location of the calendar element was wrong sometimes on systems with dual monitors.
* NullPointerException occurred when export button is pressed (export dialog doesn't appear at all) (fixed in 8.2.385).
* Attribut "Permissions" was missing in the manifest file of CC-Viewer.jar. This is required since Java 7 update 45.

### i-net DesignerXML
* It was not possible to open the Help dialog while it is already opened and minimized.
* Under Linux, running the i-net DesignerXML with limited permissions would lead to a Preferences warning being printed to the log every 30 seconds.
* Pressing "More Info" in an error box coming from the report viewer within the Designer has no effect.
* In the German version of the designer, there were some English labels mixed in with German labels in the formula editor.
* ArrayIndexOutOfBoundsException occurred if an opened sub-report was deleted and then this was undone.
* A report with an error in a formula could be loaded in the designer with the formula having a green checkbox though it had errors.
* Various L&F bugs with the Nimbus L&F were occurred.
* Parameter Field dialog:
  * Various GUI issues occurred.
  * It was possible to define illegal parameter field default values in the Parameter Field dialog, leading to errors when attempting to run the report.
  * There were some localization issues for entering limit values in the designer prompt dialog.
  * When setting a dynamic prompt with a manual SQL statement for a report with more than one data source, the data source combo box for choosing the data source was not showing, forcing the query to be run on the first data source only.
* Page Layout dialog: Various GUI issues occurred.
* Property dialogs: If all border types were set via property formula, the dialog would still show the border as being same for all edges.
* Number Format dialog: It was possible to select currency type for non-currency numbers.
* Formula Editor: Error message was displayed if constant "AdvancedHtmlText" was used in a property formula.
* Field reference was incorrect if field was used within an array in a formula.
* i-net DesignerXML Help: tree with the search results contained duplicate entries.
* ArrayIndexOutOfBoundsException occurred while opening a report.
* NullPointerException (at com.inet.designer.o.componentResized) occurred at random situations.
* Additional new lines and empty text parts were added to a text objects.
* Regression: Method BasicDesignerDataModel.loadReport(Component) was removed from API.
* Screen location of the calendar element was wrong sometimes on systems with dual monitors.
* Group Dialog: Report error "Wrong group number" occurred when trying to remove groups in sub-report.
* Designer did not start with JNLP (fixed in version 8.2.422).
* Regression: It was not possible to open the Page Layout dialog for a sub report to configure multi-column or mailing label layout (fixed in version 8.2.469).
* Error box occurred on Windows 7 during start of i-net DesignerXML if node "com\\inet\\designer\\classes" does not exist in Java preferences (fixed in 8.2.807).

### i-net Scheduler
* Adding a "cache action" while using memory cache was disabling the combo box. So it was necessary to leave the "add action" page to add another action. Now, this can be done in one step without going back.
* Temporary files for email action were sometimes not deleted. Additionally these temporary files were created in the temp directory instead of the current working directory of the scheduler.
* File Actions does not work because of an exception in the report cache (fixed in 8.2.464).

[bugfixes:de]
### i-net Crystal-Clear-Laufzeit
* In einigen Fällen wurde die Konfiguration beim Starten von i-net Crystal-Clear unnötigerweise zweimal gelesen. Dies verlangsamte die Leistung des Starts und wurde behoben.
* Bei der Verwendung von Formeln für Zahlenformateigenschaften in Kreuztabellen, die das Schlüsselwort "currentfieldvalue" enthalten, trat eine Ausnahme auf.
* "Can Grow"-Felder mit abschließenden Leerzeichen wurden mit einem unerwünschten Zeilenumbruch angezeigt.
* Es war nicht möglich, die Beschriftung "Total" in Kreuztabellen mit Sprachressourcen zu übersetzen.
* Ein Verbindungsleck ist aufgetreten, wenn die Datenbankverbindung mit der Methode setConnection gesetzt wurde und Parameterfeldwerte vom Java-Viewer angefordert wurden.
* Formelfunktion MIRR: Das Ergebnis der Formelfunktion war falsch.
* ClassCastException trat auf, wenn die Eigenschaft "Log Database Data" (CCcore-Dateierstellung) aktiviert war.
* Wurde die Textinterpretation dynamisch gesetzt und während des Berichts geändert, konnte eine seltene "ClassCastException: com.inet.report.PageBreakInfo cannot be cast to com.inet.report.layout.ric.RichHtmlPageBreakInfo" auftreten.
* In seltenen Fällen wurden Zeilen und Boxen falsch dargestellt, wenn sie im Seitenkopf oder Seitenfuß eines Berichts enthalten sind und dieser als Unterbericht hinzugefügt wurde.
* In seltenen Fällen konnte es vorkommen, dass ein Bericht falsch gespeichert wurde, was dazu führte, dass der Bericht zwar geladen, aber nicht erneut gespeichert werden konnte.
* Abfragedateien wurden nicht gefunden, wenn sie mit UNC-Namen gesetzt wurden.
* Das Aufrunden hat bei kleinen Werten und allen Werten der Eigenschaft Rundung nicht korrekt funktioniert.
* Bei der SQL-Abfrage für dynamische Eingabeaufforderungs-Standardwerte ist es nicht mehr erforderlich, dass die Spalten Wert und Beschreibung die Spalten 1 und 2 sind. Stattdessen können Sie jetzt die Spalten "Wert" und "Beschreibung" benennen und ihre Reihenfolge kann dann wie gewünscht sein.
* Der Datenbank-Metadaten-Cache verwendet keine Datenbankverbindungen, die mit der Methode setConnection gesetzt wurden.
* Regression: Ein falscher Fehler wurde ausgelöst, nachdem die gleiche Engine zweimal ausgeführt wurde.
* PDF-Export: Die Darstellung von leeren Inhalten war falsch. Die Seite in der PDF-Datei war leer, wenn das gesamte Seitenelement leer war.
* RTF-Export: Windows-Metadatei zeigt korrekten Strich mit erweitertem Stift. Dieses GDI-Objekt wird nun anstelle des einfachen Stifts verwendet.
* Datensatz-Auswahl-Formel: Fix für in-Array-Operationen, die in der Datensatzauswahlformel verwendet werden. Die in-Array-Operation wird nun immer false zurückgeben, wenn das Array leer ist. Dies wirkt sich z. B. auf eine leere mehrwertige Eingabeaufforderung aus, die ebenfalls ein leeres Array zurückgibt.
* Diagramm:
  * Falsche Beschriftung der Datenachse bei kontinuierlichen Datumsdiagrammen.
  * Der Umriss des Doughnut 2D Diagramms wurde immer gezeichnet.
  * Die Trennlinien von Ring 2D wurden nicht durch die Umrisse der Elemente definiert.
  * Die Farbreihenfolge der Diagrammelemente war von der Legende abhängig.
  * Die Liste der Legendenbeschriftungen der zweiten Gruppe wird nun nach der Sortierreihenfolge dieser Gruppe sortiert.
* SVG Bean (com.inet.report.beans.SVG): NullPointerException aufgetreten.
* Manchmal verschwand ein Abschnitt, wenn der Abschnitt Page Footer in Abhängigkeit von einer Formel unterdrückt wurde.
* RuntimeException: Field is null trat beim Öffnen eines mit Crystal Reports erstellten Berichts auf.
* Linienstile eines Feldes in einem Unterbericht wurden manchmal auch für ein Feld im Hauptbericht verwendet.
* Webserver reagiert nicht mehr, nachdem einige Fehler in der Formel für die Datensatzauswahl aufgetreten waren.
* TXT-Export: Chinesische Daten wurden manchmal verschoben, wenn die Daten das chinesische Zeichen "VIII" enthielten.
* ODBC-Treiber für Excel markieren alle Blätter als SYSTEM TABLE. Daher wurden im Visual Database Wizard keine Objekte angezeigt.
* Drill Down funktionierte wegen eines Kodierungsproblems nicht, wenn eine Skriptsprache wie ASP oder PHP verwendet wurde.
* TXT-Export: Chinesische Daten wurden manchmal verschoben.
* Falsches Ergebnis der DateDiff-Funktion mit einem DayOfWeek-Offset, wenn die Differenz ein Vielfaches von sieben Tagen war.
* IllegalArgumentException trat beim Öffnen der Berichtsdatei auf, nachdem der Typ des Parameterfeldes geändert wurde (behoben in Build 8.2.245).
* Aufgrund einer Ausnahme beim Lesen von Sproc-Parameterwerten für eine Stored Procedure (z.B. auf Informix) war der Wert für einige Stored-Procedure-Parameter null (behoben in Build 8.2.247).
* Nicht-ASCII-Zeichen in Parameterfeldnamen werden im Dialog HTML-Parameteranfrage nicht korrekt angezeigt. (in Version 8.2.305).
* Eine Endlosschleife trat auf, wenn Underlay Following Section für einen großen Abschnitt aktiviert war (behoben in Version 8.2.422).
* StackOverflowError trat auf, wenn verschachtelte if-then-else-Anweisungen in Formeln verwendet wurden (behoben in Version 8.2.436).
* Eine Endlosschleife konnte in seltenen Fällen auftreten, wenn der Metadaten-Cache aktiviert war. (behoben in Version 8.2.441).
* Sicherheitsproblem: Mit einer geänderten Berichts-URL war es möglich, Dateien aus dem i-net Crystal-Clear-Webkontext herunterzuladen, wenn die Datei crystal.war entpackt wurde (behoben in Version 8.2.445).
* Excel-Export:
  * Cross-Tab in der .xls-Datei war unvollständig. Die erste Spalte wurde nicht exportiert (behoben in Version 8.2.445).
  * Die Position des '%'-Symbols wurde nicht für die Log-Ebene abzüglich der WARNING gesetzt (behoben in Version 8.2.519).
* Datenexport:
  * Es ist vorgekommen, dass Spalten der exportierten csv-Datei Datensätze von mehreren Datenbankfeldern oder speziellen Feldern, z.B. Seitennummer, enthalten (behoben in Version 8.2.540).
* Die Eigenschaft "OnError_ExecuteSQL_WithoutSF" wurde ignoriert, wenn ein Fehler bei der Ausführung der Order By und Where Klausel auftrat (behoben in Version 8.2.540).
* Endlosschleife trat aufgrund von java.util.WeakHashMap auf, einem nicht Thread-sicheren Objekt.
* Sicherheitskorrektur zur Verhinderung von Cross-Site Scripting (XSS) (behoben in Version 8.2.959).

### i-net Crystal-Clear - Java Viewer
* Verschiedene Fehler bei der Suche mit regulären Ausdrücken im Java-Viewer sind aufgetreten.
* HTML-Fehler, die vom Server kommen, werden im Fehlerdialog des Viewers nicht mehr verstümmelt angezeigt, sondern als HTML-formatierte Fehlerbox.
* Wenn ein Eingabeaufforderungsfeld so eingestellt war, dass es nur Standardwerte akzeptiert, aber keine Standardwerte hatte, wurde es als nicht editierbares leeres Feld angezeigt. Jetzt akzeptiert es in diesem Fall eine Benutzereingabe.
* Bei der Einstellung von leeren Standardwerten und "nur Standardwerte" konnte es zu Problemen mit der Eingabeaufforderung kommen, z. B. zu einem leeren Eingabeaufforderungsfeld.
* Das Drücken von "More Info" in einer Fehlerbox aus dem Report-Viewer innerhalb des Designers hat keinen Effekt.
* Eine seltene IndexOutOfBoundsException trat im Viewer auf, wenn versucht wurde, einen Bericht abzurufen, für den der Client keine Leseberechtigung hatte.
* Links zu "file:"-Dateien in einem Bericht funktionierten im Viewer-Applet aufgrund von Java-Sicherheitsproblemen nicht. Dies wurde für Java 6 behoben.
* Querformatige Berichte wurden nicht korrekt gedruckt, wenn im Druckdialog des Java Report Viewers "2 Seiten pro Blatt" eingestellt war.
* In einigen Fällen war der Status des PrinterJobProgress nach dem Auftreten eines Fehlers falsch. Daher hat der PrinterJobProgress den Fehler nicht zurückgegeben.
* Eine NullPointerException im RichTextLayouter konnte in seltenen Fällen bei Elementen mit gemischten Text- und Feldteilen, die sich über mehrere Zeilen erstrecken, auftreten.
* Ein Speicherleck im Viewer trat auf, wenn einzelne Berichtsviewer geöffnet und geschlossen wurden.
* Der Dialog für die Eingabeaufforderung wurde nach dem Aktualisieren nicht angezeigt, wenn neue URLRenderData verwendet wurden, wenn "promptonrefresh=true" als URL-Eigenschaft angegeben wurde, anstatt über die API gesetzt zu werden.
* Die Position des Kalenderelements auf dem Bildschirm war auf Systemen mit zwei Monitoren manchmal falsch.
* NullPointerException trat auf, wenn die Export-Schaltfläche gedrückt wurde (der Export-Dialog erschien nicht) (behoben in 8.2.385).
* Das Attribut "Permissions" fehlte in der Manifestdatei von CC-Viewer.jar. Dies ist seit Java 7 Update 45 erforderlich.

### i-net DesignerXML
* Es war nicht möglich, den Hilfedialog zu öffnen, wenn er bereits geöffnet und minimiert war.
* Unter Linux führte das Ausführen von i-net DesignerXML mit eingeschränkten Rechten dazu, dass alle 30 Sekunden eine Warnung zu den Voreinstellungen in das Protokoll gedruckt wurde.
* Das Drücken von "More Info" in einer Fehlerbox aus dem Report-Viewer innerhalb des Designers hat keinen Effekt.
* In der deutschen Version des Designers waren im Formeleditor einige englische Bezeichnungen mit deutschen Bezeichnungen vermischt.
* ArrayIndexOutOfBoundsException trat auf, wenn ein geöffneter Unterbericht gelöscht wurde und dies anschließend rückgängig gemacht wurde.
* Ein Bericht mit einem Fehler in einer Formel konnte im Designer geladen werden, wobei die Formel ein grünes Kontrollkästchen hatte, obwohl sie Fehler enthielt.
* Verschiedene L&F-Fehler mit dem Nimbus L&F wurden behoben.
* Parameterfeld-Dialog:
  * Es traten verschiedene GUI-Probleme auf.
  * Es war möglich, unzulässige Standardwerte für Parameterfelder im Parameterfelddialog zu definieren, was zu Fehlern führte, wenn man versuchte, den Bericht auszuführen.
  * Es gab einige Lokalisierungsprobleme bei der Eingabe von Grenzwerten im Dialogfeld für die Designer-Eingabeaufforderung.
  * Beim Festlegen einer dynamischen Eingabeaufforderung mit einer manuellen SQL-Anweisung für einen Bericht mit mehr als einer Datenquelle wurde das Kombinationsfeld für die Auswahl der Datenquelle nicht angezeigt, so dass die Abfrage nur auf der ersten Datenquelle ausgeführt werden konnte.
* Dialogfeld Seitenlayout: Verschiedene GUI-Probleme traten auf.
* Eigenschaftsdialoge: Wenn alle Rahmentypen über eine Eigenschaftsformel festgelegt wurden, zeigte der Dialog immer noch an, dass der Rand für alle Kanten gleich war.
* Dialogfeld "Zahlenformat": Es war möglich, den Währungstyp für Nicht-Währungszahlen auszuwählen.
* Formel-Editor: Es wurde eine Fehlermeldung angezeigt, wenn die Konstante "AdvancedHtmlText" in einer Eigenschaftsformel verwendet wurde.
* Feldreferenz war falsch, wenn Feld innerhalb eines Arrays in einer Formel verwendet wurde.
* i-net DesignerXML Hilfe: Baum mit den Suchergebnissen enthielt doppelte Einträge.
* ArrayIndexOutOfBoundsException trat beim Öffnen eines Berichts auf.
* NullPointerException (bei com.inet.designer.o.componentResized) trat in zufälligen Situationen auf.
* Zusätzliche neue Zeilen und leere Textteile wurden zu einem Textobjekt hinzugefügt.
* Regression: Die Methode BasicDesignerDataModel.loadReport(Component) wurde aus der API entfernt.
* Die Position des Kalenderelements auf dem Bildschirm war manchmal auf Systemen mit zwei Monitoren falsch.
* Gruppen-Dialog: Report-Fehler "Falsche Gruppennummer" trat auf, wenn versucht wurde, Gruppen in Unterberichten zu entfernen.
* Der Designer wurde nicht mit JNLP gestartet (behoben in Version 8.2.422).
* Regression: Es war nicht möglich, den Dialog "Seitenlayout" für einen Unterbericht zu öffnen, um ein mehrspaltiges Layout oder ein Versandetikett zu konfigurieren (behoben in Version 8.2.469).
* Unter Windows 7 trat beim Start von i-net DesignerXML eine Fehlermeldung auf, wenn der Knoten "com\\inet\designer\\classes" in den Java-Voreinstellungen nicht vorhanden war (behoben in 8.2.807).

### i-net Scheduler
* Das Hinzufügen einer "Cache-Aktion" bei Verwendung des Speicher-Caches deaktivierte das Kombinationsfeld. Daher war es notwendig, die Seite "Aktion hinzufügen" zu verlassen, um eine weitere Aktion hinzuzufügen. Jetzt kann dies in einem Schritt erfolgen, ohne zurück zu gehen.
* Temporäre Dateien für E-Mail-Aktionen wurden manchmal nicht gelöscht. Außerdem wurden diese temporären Dateien im Temp-Verzeichnis statt im aktuellen Arbeitsverzeichnis des Schedulers angelegt.
* Datei-Aktionen funktionieren nicht aufgrund einer Ausnahme im Berichts-Cache (behoben in 8.2.464).

[security]

[security:de]
